org.apache.coyote.http11.filters

## Class SavedRequestInputFilter

- java.lang.Object
- - org.apache.coyote.http11.filters.SavedRequestInputFilter

- All Implemented Interfaces:
    InputFilter, InputBuffer

      public class SavedRequestInputFilter
      extends Object
      implements InputFilter

  Input filter responsible for replaying the request body when restoring the saved request after FORM authentication.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected ByteChunk` | `input` The original request body.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SavedRequestInputFilter(ByteChunk input)` Create a new SavedRequestInputFilter.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `available()` Amount of bytes still available in a buffer.
    `int` | `doRead(ByteChunk chunk, Request request)` Read bytes.
    `long` | `end()` End the current request (has no effect).
    `ByteChunk` | `getEncodingName()` Return the name of the associated encoding; here, the value is null.
    `void` | `recycle()` Make the filter ready to process the next request.
    `void` | `setBuffer(InputBuffer buffer)` Set the next buffer in the filter pipeline (has no effect).
    `void` | `setRequest(Request request)` Set the content length on the request.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### input

          protected ByteChunk input

      The original request body.

  - ### Constructor Detail

    - #### SavedRequestInputFilter

          public SavedRequestInputFilter(ByteChunk input)

      Create a new SavedRequestInputFilter.
      Parameters:
        `input` - The saved request body to be replayed.

  - ### Method Detail

    - #### doRead

          public int doRead(ByteChunk chunk,
                   Request request)
                     throws IOException

      Read bytes.
      Specified by:
        `doRead` in interface `InputFilter`
      Specified by:
        `doRead` in interface `InputBuffer`
      Returns:
        Number of bytes read.
      Throws:
        `IOException`

    - #### setRequest

          public void setRequest(Request request)

      Set the content length on the request.
      Specified by:
        `setRequest` in interface `InputFilter`

    - #### recycle

          public void recycle()

      Make the filter ready to process the next request.
      Specified by:
        `recycle` in interface `InputFilter`

    - #### getEncodingName

          public ByteChunk getEncodingName()

      Return the name of the associated encoding; here, the value is null.
      Specified by:
        `getEncodingName` in interface `InputFilter`

    - #### setBuffer

          public void setBuffer(InputBuffer buffer)

      Set the next buffer in the filter pipeline (has no effect).
      Specified by:
        `setBuffer` in interface `InputFilter`

    - #### available

          public int available()

      Amount of bytes still available in a buffer.
      Specified by:
        `available` in interface `InputFilter`

    - #### end

          public long end()
                   throws IOException

      End the current request (has no effect).
      Specified by:
        `end` in interface `InputFilter`
      Returns:
        0 is the expected return value. A positive value indicates that too many bytes were read. This method is allowed to use buffer.doRead to consume extra bytes. The result of this method can't be negative (if an error happens, an IOException should be thrown instead).
      Throws:
        `IOException`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.